/*
 * TD Structures de données et algorithmes
 * Université de Strasbourg
 * bfreeling@unistra.fr
 */
#include "base.h"

/*
 *
 * typedef struct strliste
 * {
 *     struct strliste *s;
 *     Nat v;
 * } Strliste, *Liste;
 *
 * // pré adji(l, x, i) = 1 =< i =< lgr(l) +1
 * adji(Liste l, int i, Nat x)
 * {
 *     if (i == 1)
 *         return adjt(l, x);
 *     if (i == lgr(l) + 1)
 *         return adjq(l, x);
 *     else
 *     {
 *         Nat k = 1;
 *         Liste l1 = l->s;
 *         while (k != i - 1)
 *         {
 *             l1 = l->s;
 *             k++;
 *         }
 *         Liste new = MALLOC(Strliste);
 *         new->v = x;
 *         new->s = l1->s;
 *         l1->s = new;
 *         return l;
 *     }
 * }
 *
 * ajout_trié(Liste l, Nat v)
 * {
 *     if (l == NULL)
 *     {
 *         return adjt(l, v);
 *     }
 *     if (v < l->v)
 *     {
 *         return adjq(l, v);
 *     }
 *     else if (v > l->s->v)
 *     {
 *         return adjt(l, v);
 *     }
 *     else
 *     {
 *         Liste temp = l;
 *         while (temp->s != l)
 *         {
 *             if (v <= temp->v && v > temp->s->v)
 *             {
 *                 Liste new = MALLOC(Strliste);
 *                 new->v = v;
 *                 new->s = temp->s;
 *                 temp->s = new;
 *             }
 *             temp = temp->s;
 *         }
 *         return l;
 *     }
 * }
 *
 * */

typedef struct strliste
{
    float x;
    struct strliste *s;
    struct strliste *p;
} Strliste, *Liste;

/* pré : split(l) = nonvide(l); */
Liste split(Liste l)
{
    Liste new = MALLOC(Strliste);
    Liste temp = l->s;
    new->s = temp;
    new->p = l;
    l->s = new;
    float v = l->x / 2;
    l->x = v;
    new->x = v;
    return l;
}