#ifndef CLAN 
#define CLAN 

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <stdbool.h>

#include "base.h"
#include "personne.c"

typedef struct stPer { personne per ;       // les données de la personne
        struct stPer *next_comp;            // le compagnon suivant dans le clan
        struct stPer *next_pop;             // la personne suiv. dans la population
} *Population, Membre;                      // plusieurs noms pour la lisibilité

typedef struct stClan { Membre * premier ;  // début de la liste du clan
        Membre * dernier ;                  // le dernier est le représentant
        struct stClan *next_clan;           // chaînage
} *Clans, StrClans;

typedef struct { Population pop;            // liste de la population entière
        Clans clans;                        // liste des clans
} Jeu;

Jeu jeu_vide();
Population jeu_adresse_chef(Population mclan );
void jeu_print_pop(Jeu j);
void jeu_print_clan(Jeu j, Population mclan);
Jeu jeu_fusion(Jeu j, Clans clan1, Clans clan2);
Jeu jeu_adj_joueur(Jeu j, personne p);

#endif