#ifndef PILE_CHAR_H
#define PILE_CHAR_H

#include "base.h"

// Constante
#define MAX_P 50

// Structure de pile contiguë
typedef struct {
    Nat tab[MAX_P];
    Nat h; // Hauteur de la pile
} Pile;

// Fonctions principales
Pile pilenouv();
Pile empiler(Pile p, Nat c);

//Precondition : pile non vide
Pile depiler(Pile p);
Bool vide(Pile p);

//Precondition : pile non vide
Nat sommet(Pile p);
Nat hauteur(Pile p);

#endif
