#ifndef TP1_EX2_H
#define TP1_EX2_H

#include "base.h"

// Structure de nœud de pile chaînée
typedef struct spile {
    Nat v;              // Valeur du caractère
    struct spile* s;    // Pointeur vers l'élément suivant
} Spile, *Pile;

// Fonctions principales
Pile pilenouv();                      // Crée une pile vide
Pile empiler(Pile p, Nat c);          // Ajoute un élément à la pile
Pile depiler(Pile p);                 // Retire un élément de la pile
Bool vide(Pile p);                    // Vérifie si la pile est vide

//Precondition : Pile non vide
Nat sommet(Pile p);                   // Retourne l'élément au sommet
Nat hauteur(Pile p);                  // Calcule la hauteur de la pile
void liberer(Pile p);                 // Libère toute la mémoire de la pile

#endif
