#include "base.h"

// Structure d'une liste simplement chaînée
typedef struct strliste {
    Nat v;                  // Valeur stockée
    struct strliste *s;     // Pointeur vers l'élément suivant
} Strliste, *Liste;

// Question 1
Liste listenouv();

//Precondition : Liste non vide
Nat tete(Liste l);

Liste adjt(Liste l, Nat x);

Liste supt(Liste l);

Nat longueur(Liste l);

Bool est_vide(Liste l);

Bool appartient(Liste l, Nat x);

// Question 2

Liste premiere_Occ(Liste l, Nat x);

Liste change_pemiere_Occ(Liste l, Nat x, Nat y);

Liste supprime_premiere_Occ(Liste l, Nat x);

// Question 3

//Precondition : Liste non vide
Nat queue(Liste l);

Liste adjq(Liste l, Nat x);

Liste supq(Liste l);

// Question 4

//Precondition : i est entre 0 et longueur - 1

Nat acces_ieme(Liste l, int i);

Liste ajout_ieme_position(Liste l, int i, Nat x);

Liste supp_ieme_position(Liste l, int i);

