#include "base.h"

// Structure d'une liste circulaire
typedef struct strliste {
    Nat v;                  // Valeur stockée
    struct strliste* s;     // Pointeur vers l'élément suivant
} Strliste, *Liste;

// Question 2 : Opérations standard

Liste listenouv();

//Precondition : liste non vide
Nat tete(Liste l);

Liste adjt(Liste l, Nat x);

Liste supt(Liste l);

Nat longueur(Liste l);

Bool est_vide(Liste l);

Bool appartient(Liste l, Nat x);

// Question 3 : Opérations en dernière position

//Precondition : liste non vide
Nat queue(Liste l);

Liste adjq(Liste l, Nat x);

Liste supq(Liste l);


