#include "base.h"
#define MAX_P 50

typedef struct
{
    char tab[MAX_P];
    Nat h;
} Pile;

Pile pilenouv()
{
    Pile p;
    p.h = 0;
    return p;
}

Pile empiler(Pile p, char S)
{
    if (p.h == MAX_P)
        printf("Pile pleine\n");
    else
    {
        p.tab[p.h] = S;
        p.h++;
    }
    return p;
}

Pile depiler(Pile p)
{
    if (p.h == 0)
        printf("Pile vide\n");
    else
        p.h--;
    return p;
}

char sommet(Pile p)
{
    if (p.h == 0)
        return p.h;
    else
        return p.tab[p.h - 1];
}

Pile remplacer(Pile p, char S)
{
    p.tab[p.h - 1] = S;
    return p;
}

Bool vide(Pile p) { return p.h == 0; }

Nat hauteur(Pile p) { return p.h; }