#include "base.h"
#define MAX_P 50

typedef struct {
    char tab[MAX_P];
    Nat h;
} Pile;

Pile pilenouv();
//La fonction crée une nouvelle pile vide.

Pile empiler(Pile p, Nat S);
//La fonction prend un élément S et l'ajoute au sommet de la pile.

Pile depiler(Pile p);
//La fonction supprime l'élément du sommet de la pile.
//Précondition : Pile non vide.

char sommet(Pile p);
//La fonction renvoie l'élément du sommet de la pile.
//Précondition : Pile non vide.

Pile remplacer(Pile p, Nat S);
//La fonction remplace l'élément du sommet de la pile par S.
//Précondition : Pile non vide.

Pile vide(Pile p);
//La fonction est un test de vacuité pour la pile placé en argument.
//La fonction renvoie 1 si la pile est vide, 0 sinon.

Nat hauteur(Pile p);
//La fonction renvoie la hauteur de la pile.