#include "base.h"
#define MAX_P 50

typedef struct strfile
{
    Nat x;             // valeur
    struct strfile *s; // suivant
} Strfile;

typedef struct sfile
{
    Strfile *h; // tête
    Strfile *q; // queue
} File;

File filenouv();
// La fonction crée une nouvelle file vide.

File adjq(File f, Nat S);
// La fonction prend un élément S et l'ajoute en queue de file.

Bool vide(File f);
// La fonction est un test de vacuité pour la pile placé en argument.
// La fonction renvoie Vrai si la pile est vide, Faux sinon.

File lgr(File f);
// La fonction renvoie la longueur de la file placé en argmuent.

File supt(File f);
// La fonction supprime l'élément de tête de la file placé en argmuent.
// Précondition : La file doit être non vide.

File tete(File f);
// La fonction renvoie l'éméent de tête de la file placé en argument.
// Précondition : La file doit être non vide.