#include "base.h"
typedef int S;

typedef struct strListe
{
    S v;                // valeur
    struct strListe *s; // suivant
} Strliste, *Liste;

Liste listenouv()
{
    Liste l = NULL;
    return l;
}

Liste adjt(Liste l, S v)
{
    Liste l1 = MALLOC(Strliste);
    l1->s = l;
    l1->v = v;
    return l1;
}

Liste supt(Liste l)
{
    if (l == NULL)
    {
        printf("Liste vide, suppression impossible.\n");
        return NULL;
    }
    Liste tmp = l; // On garde une référence au premier élément.
    l = l->s;      // Mise à jour de l pour pointer le reste de la liste.
    FREE(tmp);     // On libère le premier élément.
    return l;      // On retourne le reste de la liste.
}

Nat lgr(Liste l)
{
    Nat n = 0;
    while (l != NULL)
    {
        n++;
        l = l->s; // Passer à l'élément suivant
    }
    return n;
}

Bool vide(Liste l)
{
    return l == NULL;
}

Bool app(Liste l, S v)
{
    while (l != NULL)
    {
        if (l->v = v)
        {
            return vrai;
        }
        l = l->s;
    }
    return faux;
}

Liste recherche(Liste l, S v)
{
    while (l != NULL)
    {
        if (l->v == v)
        {
            return l;
        }
        l = l->s;
    }
    return NULL;
}

Liste rech_precedent(Liste l, S v)
{
    Liste precedent = NULL;
    while (l != NULL)
    {
        if (l->v == v)
        {
            return precedent;
        }
        precedent = l;
        l = l->s;
    }
    return NULL;
}
