#include "base.h"

typedef struct strliste
{
    S v;                // valeur
    struct strliste *s; // suivant
} Strliste, *Liste;

Liste listenouv();
// La fonction crée une liste vide.

Liste adjt(Liste l, S v);
/* La fonction prend un élément V de type S
et une liste L puis retourne une liste L avec l'élément V. */
// Préconditions : Aucune

Liste supt(Liste l);
// La fonction prend une liste L, supprime son élément de tête et retourne cette liste.
// Préconditions : Liste non vide.

Nat lgr(Liste l);
// La fonction renvoie la longueur de la liste.

Bool vide(Liste l);
// Test de vacuité pour la liste L.

Bool app(Liste l, S v);
// Test d'appartenance de l'élément V est dans la liste L.

Liste recherche(Liste l, S v);
// Trouver la première occurrence d'un élément.