// TD Structures de données et algorithmes
// Université de Strasbourg
// bfreeling@unistra.fr

#include "base.h"

typedef struct strlist
{
    int v;
    struct strlist *s;
} Strlist, *Liste;

listenouv()
{
    Liste l = NULL;
    return l;
}

adjt(Liste l, int v)
{
    Liste new = MALLOC(Strlist);
    new->s = l;
    new->v = v;
    return new;
}

Nat lgr(Liste l)
{
    Nat n = 0;
    while (l != NULL)
    {
        n++;
        l = l->s; // Passer à l'élément suivant
    }
    return n;
}

Liste adjq(Liste l, int v)
{
    Liste new = MALLOC(Strlist);
    new->v = v;
    new->s = NULL;
    if (l == NULL)
    {
        return new;
    }
    else
    {
        while (l->s != NULL)
        {
            l = l->s;
        }
        l->s = new;
        return l;
    }
}

Liste supq(Liste l, int v)
{
    if (l == NULL)
    {
        printf("Suppression impossible.\n");
        return NULL;
    }
    if (l->s == NULL)
    {
        free(l);
        return NULL;
    }
    while (new->s->s)
    {
        new = new->s;
    }
    free(new->s);
    new->s = NULL;
    return l;
}

// Liste chainée circulaire

Liste supq(Liste l)
{
    if (l == NULL)
    {
        return l;
    }
    if (l->s == l)
    {
        free(l);
        return NULL;
    }
    Liste new = l;
    while (new->s->s != l)
    {
        new = new->s;
    }
    free(new->s);
    l->s = l;
    return l;
}
