#include "tp1_ex1.h"

// Crée une pile vide
Pile pilenouv() {
    Pile p;
    p.h = 0; // Initialisation de la hauteur à 0
    return p;
}

// Ajoute un entier à la pile
Pile empiler(Pile p, Nat c) {
    if (p.h < MAX_P) {
        p.tab[p.h++] = c;
    } else {
        printf("Erreur : Pile pleine !\n");
    }
    return p;
}

// Retire un entier de la pile
Pile depiler(Pile p) {
    p.h--;
    return p;
}

// Vérifie si la pile est vide
Bool vide(Pile p) {
    return (p.h == 0);
}

// Retourne le sommet de la pile
Nat sommet(Pile p) {
    return p.tab[p.h - 1];
}

// Retourne la hauteur de la pile
Nat hauteur(Pile p) {
    return p.h;
}
