#include "tp1_ex2.h"

// Crée une pile vide 
Pile pilenouv() {
    return NULL;
}

// Ajoute un entier à la pile
Pile empiler(Pile p, Nat c) {
    Pile nouv = MALLOC(Spile);
    nouv->v = c;
    nouv->s = p;
    return nouv;
}

// Retire un entier de la pile
Pile depiler(Pile p) {
    Pile suivant = p->s;
    FREE(p); // Libère la mémoire du nœud actuel
    return suivant;
}

// Vérifie si la pile est vide
Bool vide(Pile p) {
    return p == NULL;
}

// Retourne l'élément au sommet de la pile
Nat sommet(Pile p) {
    return p->v;
}

// Calcule la hauteur de la pile
Nat hauteur(Pile p) {
    Nat h = 0;
    while (p != NULL) {
        h++;
        p = p->s;
    }
    return h;
}


// fonction bonus pour liberer la memoire 
// Libère toute la mémoire de la pile
void liberer(Pile p) {
    while (!vide(p)) {
        p = depiler(p);
    }
}
