#include "tp2_ex1.h"

// Crée une file vide
File filenouv() {
    File f;
    f.h = 0;
    f.l = 0;
    return f;
}

// Ajoute un élément à la fin de la file
File adjq(File f, Nat val) {
    if (f.l < MAX_P) {
        f.tab[(f.h + f.l) % MAX_P] = val;
        f.l++;
    } else {
        printf(" File pleine !\n");
    }
    return f;
}

// Supprime l'élément en tête de la file
File supt(File f) {
    f.h = (f.h + 1) % MAX_P;
    f.l--;
    return f;
}

// Vérifie si la file est vide
Bool vide(File f) {
    return f.l == 0;
}

// Retourne l'élément en tête de la file
Nat tete(File f) {
    return f.tab[f.h];
}

// Retourne la longueur de la file
Nat longueur(File f) {
    return f.l;
}
