#include "base.h"

// Constante
#define MAX_P 50

// Structure de la file contiguë
typedef struct {
    Nat tab[MAX_P]; // Tableau pour stocker les éléments
    Nat h;          // Indice de la tête
    Nat l;          // Longueur de la file
} File;

// Fonctions principales
File filenouv();                  // Crée une file vide

File adjq(File f, Nat val);       // Ajoute un élément à la fin

//Precondition : File non vide
//pre supt(f) = !vide(f)
File supt(File f);                // Supprime l'élément en tête

Bool vide(File f);                // Vérifie si la file est vide

//Precondition : File non vide
//pre tete(f) = !vide(f)
Nat tete(File f);                 // Retourne l'élément en tête

Nat longueur(File f);             // Retourne la longueur de la file

