#include "tp3_ex1.h" // Pour le simple chaînage
//#include "tp3_ex2.h" // Pour le simple chaînage circulaire

int main() {
    Liste l = listenouv();

    printf("\n--- Tests sur la liste vide ---\n");
    printf("Longueur : %u\n", longueur(l));

    printf("\n--- Ajout en tête ---\n");
    l = adjt(l, 10);
    l = adjt(l, 20);
    l = adjt(l, 30);

    printf("\n--- Ajout en queue ---\n");
    l = adjq(l, 40);

    printf("\n--- Suppression en tête ---\n");
    l = supt(l);

    printf("\n--- Suppression en queue ---\n");
    l = supq(l);

    printf("\n--- Appartenance ---\n");
    printf("20 appartient ? %s\n", appartient(l, 20) ? "Oui" : "Non");
    printf("50 appartient ? %s\n", appartient(l, 50) ? "Oui" : "Non");

    printf("\n--- Accès à la tête et à la queue ---\n");
    printf("Tête : %u\n", tete(l));
    printf("Queue : %u\n", queue(l));

    printf("\n--- Opérations sur i-ème position ---\n");
    printf("Accès au 2ème élément : %u\n", acces_ieme(l, 2));
    l = ajout_ieme_position(l, 2, 25);
    printf("Après ajout à la 2ème position.\n");
    l = supp_ieme_position(l, 3);
    printf("Après suppression à la 3ème position.\n");

    printf("\n--- Opérations sur la première occurrence ---\n");
    l = change_pemiere_Occ(l, 25, 99);
    printf("Après changement de la première occurrence de 25 par 99.\n");
    l = supprime_premiere_Occ(l, 99);
    printf("Après suppression de la première occurrence de 99.\n");

    printf("\n--- Libération de la liste ---\n");
    liberer(l);

    return 0;
}
