#include "tp4_ex1.h"
#include "tp4_ex2.h"

int main() {
    Liste l = listenouv();

    // Ajouter des éléments
    l = adjt(l, 10);
    l = adjt(l, 20);
    l = adjt(l, 30); // Liste : [30 -> 20 -> 10]

    printf("\n--- Parcours avec l'itérateur ---\n");
    Iter i = init(l);

    printf("Valeurs de la liste : ");
    while (!end(i)) {
        printf("%u -> ", value(i));
        next(i);
    }
    printf("NULL\n");
    free_iter(i);

    printf("\n--- Recherche d'un élément ---\n");
    Nat x = 20;
    printf("Recherche de %u : %s\n", x, chercher_element(l, x) ? "Trouvé" : "Non trouvé");

    x = 40;
    printf("Recherche de %u : %s\n", x, chercher_element(l, x) ? "Trouvé" : "Non trouvé");

    // Libérer la liste
    while (!est_vide(l)) {
        l = supt(l);
    }

    return 0;
}
