
#include "tp4_ex1.h"

// Structure pour un itérateur sur une liste doublement chaînée
typedef struct {
    Liste first; // Premier élément de la liste
    Liste cur;   // Élément courant
    Bool fin;    // Vrai si cur est sur le dernier élément
} *Iter;

// Création et gestion de l'itérateur

Iter init(Liste L);              // Initialise un itérateur sur la liste

Bool end(Iter i);                // Vérifie si l'itérateur est en fin de liste

Iter next(Iter i);               // Avance l'itérateur au prochain élément

Iter prev(Iter i);               // Recule l'itérateur au précédent élément

//Precondition : end(i) = faux
Nat value(Iter i);               // Retourne la valeur de l'élément courant

void free_iter(Iter i);          // Libère la mémoire allouée à l'itérateur

// Recherche d'un élément avec un itérateur
Bool chercher_element(Liste l, Nat x);

