#include "tp5.h"


/* code chatgpt, avec bcp d'erreurs


// Crée une personne
Personne per_mk(Nat id, Nat age, Car genre) {
    Personne p;
    p.id = id;
    p.age = age;
    p.genre = genre;
    return p;
}

// Retourne l'identifiant d'une personne
Nat per_id(Personne p) {
    return p.id;
}

// Retourne l'âge d'une personne
Nat per_age(Personne p) {
    return p.age;
}

// Retourne le genre d'une personne
Car per_genre(Personne p) {
    return p.genre;
}

// Crée un jeu vide
Jeu jeu_vide() {
    Jeu j;
    j.pop = NULL;
    j.clans = NULL;
    return j;
}

// Retourne l'adresse du chef d'un clan
Population jeu_adresse_chef(Membre membre_clan) {
    if (!membre_clan) return NULL;
    return membre_clan->next_comp ? membre_clan->next_comp : membre_clan;
}

// Affiche la population entière
void jeu_print_pop(Jeu j) {
    Population cur = j.pop;
    printf("Population du jeu :\n");
    while (cur) {
        printf("ID: %u, Âge: %u, Genre: %c\n", cur->per.id, cur->per.age, cur->per.genre);
        cur = cur->next_pop;
    }
}

// Affiche les membres d'un clan
void jeu_print_clan(Jeu j, Membre membre_clan) {
    if (!membre_clan) {
        printf("Clan vide !\n");
        return;
    }
    printf("Membres du clan :\n");
    Membre cur = membre_clan;
    while (cur) {
        printf("ID: %u, Âge: %u, Genre: %c\n", cur->per.id, cur->per.age, cur->per.genre);
        cur = cur->next_comp;
    }
}

// Fusionne deux clans
Jeu jeu_fusion(Jeu j, Clans clan1, Clans clan2) {
    if (!clan1 || !clan2) return j;

    // Concaténer les listes des deux clans
    if (clan1->dernier) {
        clan1->dernier->next_comp = clan2->premier;
        clan1->dernier = clan2->dernier;
    } else {
        clan1->premier = clan2->premier;
        clan1->dernier = clan2->dernier;
    }

    // Supprimer clan2 de la liste des clans
    Clans cur = j.clans, prev = NULL;
    while (cur && cur != clan2) {
        prev = cur;
        cur = cur->next_clan;
    }
    if (prev) prev->next_clan = cur->next_clan;
    else j.clans = cur->next_clan;

    FREE(cur);
    return j;
}

// Ajoute une personne au jeu et crée un clan
Jeu jeu_adj_joueur(Jeu j, Personne p) {
    // Vérifier si l'identifiant existe déjà
    Population cur = j.pop, prev = NULL;
    while (cur && cur->per.id < p.id) {
        prev = cur;
        cur = cur->next_pop;
    }
    if (cur && cur->per.id == p.id) {
        printf("Erreur : Identifiant déjà utilisé !\n");
        return j;
    }

    // Créer le nouveau joueur
    Population new_joueur = MALLOC(struct stPer);
    new_joueur->per = p;
    new_joueur->next_pop = cur;
    new_joueur->next_comp = NULL;

    // Insérer dans la population
    if (prev) prev->next_pop = new_joueur;
    else j.pop = new_joueur;

    // Créer un nouveau clan
    Clans new_clan = MALLOC(StrClan);
    new_clan->premier = new_joueur;
    new_clan->dernier = new_joueur;
    new_clan->next_clan = j.clans;

    j.clans = new_clan;
    return j;
}

// Retire un joueur du jeu
Jeu jeu_retire_joueur(Jeu j, Nat id) {
    // Retirer de la population
    Population cur = j.pop, prev = NULL;
    while (cur && cur->per.id != id) {
        prev = cur;
        cur = cur->next_pop;
    }
    if (!cur) {
        printf("Erreur : Joueur non trouvé !\n");
        return j;
    }

    if (prev) prev->next_pop = cur->next_pop;
    else j.pop = cur->next_pop;

    // Retirer du clan
    Clans clan_cur = j.clans;
    while (clan_cur) {
        if (clan_cur->premier == cur) {
            clan_cur->premier = cur->next_comp;
            if (!clan_cur->premier) { // Clan vide
                // Supprimer le clan
                Clans tmp = clan_cur;
                if (tmp == j.clans) {
                    j.clans = tmp->next_clan;
                } else {
                    Clans cur_clan = j.clans;
                    while (cur_clan->next_clan != tmp) {
                        cur_clan = cur_clan->next_clan;
                    }
                    cur_clan->next_clan = tmp->next_clan;
                }
                FREE(tmp);
                break;
            }
        } else {
            Membre membre_cur = clan_cur->premier;
            while (membre_cur && membre_cur->next_comp != cur) {
                membre_cur = membre_cur->next_comp;
            }
            if (membre_cur) membre_cur->next_comp = cur->next_comp;
        }
        clan_cur = clan_cur->next_clan;
    }
    FREE(cur);
    return j;
}
*/