#include "tele.h"

int main()
{
	// Pour tester votre programme décommentez les lignes qui correspondent à l'exercice

	// EXO 1 : Tests sur les programmes et les chaines
	//----------------------------------------------------------------------------------------------------------------------------------------------

	printf("Exo 1:\n");
	Programme p = creer_programme(1, "Meteo");
	Programme p1 = creer_programme(1, "JT");
	Programme p2 = creer_programme(1, "NCIS");
	Programme p3 = creer_programme(1, "Dr House");
	Programme p4 = creer_programme(1, "Game of Thrones");
	Programme p5 = creer_programme(2, "Avengers");
	Programme p6 = creer_programme(1, "Malcolm");
	Programme p7 = creer_programme(3, "Narnia");
	Chaine c = creer_chaine(10);
	printf("Le retour de chaine_vide doit ici être à 1, il est à %d\n", chaine_vide(c));
	Chaine c2 = creer_chaine(1);
	Chaine c3 = creer_chaine(5);
	c = ajouter_programme(c, p);
	c = ajouter_programme(c, p1);
	c = ajouter_programme(c, p2);
	c2 = ajouter_programme(c2, p3);
	c2 = ajouter_programme(c2, p4);
	c2 = ajouter_programme(c2, p5);
	c3 = ajouter_programme(c3, p6);
	c3 = ajouter_programme(c3, p7);
	printf("Le programme actuelle de cette chaine est %s et la réponse juste est : Meteo\n", programme_actuel(c).nom_du_programme);
	c = defiler_programme(c);
	printf("Après avoir fait défiler le programme, le programme actuel de cette chaine est %s et la réponse juste est : JT\n", programme_actuel(c).nom_du_programme);
	c = defiler_programme(c);
	printf("Le retour de chaine_vide doit ici être à 0, il est à %d\n", chaine_vide(c));
	c = defiler_programme(c);
	printf("Le retour de chaine_vide doit ici être à 1, il est à %d\n", chaine_vide(c));

	//----------------------------------------------------------------------------------------------------------------------------------------------

	// EXO 2 : creation d'une télé
	//----------------------------------------------------------------------------------------------------------------------------------------------

	printf("\n\nExo 2:\n");
	Tele t = creer_tele();
	printf("Le retour de tele_vide doit ici être à 1, il est à %d\n", tele_vide(t));
	t = ajouter_chaine(t, c2);
	printf("Le retour de tele_vide doit ici être à 0, il est à %d\n", tele_vide(t));
	t = ajouter_chaine(t, c3);
	t = detruire_tele(t);
	printf("Le retour de tele_vide doit ici être à 1, il est à %d\n", tele_vide(t));

	//----------------------------------------------------------------------------------------------------------------------------------------------

	// EXO 3 : Se déplacer dans la télé
	//----------------------------------------------------------------------------------------------------------------------------------------------

	printf("\n\nExo 3:\n");
	c = ajouter_programme(c, p);
	c = ajouter_programme(c, p1);
	c = ajouter_programme(c, p2);
	t = ajouter_chaine(t, c);
	t = ajouter_chaine(t, c2);
	t = ajouter_chaine(t, c3);
	programme_tele_actuel(t);
	t = chaine_suivante(t);
	programme_tele_actuel(t);
	t = chaine_suivante(t);
	programme_tele_actuel(t);
	t = chaine_suivante(t);
	programme_tele_actuel(t);
	t = chaine_precedente(t);
	programme_tele_actuel(t);
	printf("L'ordre attendu des chaines doit être 1 - 5 - 10 - 1 - 10\n");
	t = chaine_suivante(t);
	t = detruire_tele(t);

	//----------------------------------------------------------------------------------------------------------------------------------------------

	// EXO 4 : Avancer dans le temps
	//----------------------------------------------------------------------------------------------------------------------------------------------

	// printf("\n\nExo 4:\n");

	// c = ajouter_programme(c,p);
	// c = ajouter_programme(c,p1);
	// c = ajouter_programme(c,p2);

	// t = ajouter_chaine(t,c);
	// t = ajouter_chaine(t,c2);
	// t = ajouter_chaine(t,c3);

	// programme_tele_actuel(t);
	// t = chaine_suivante(t);
	// programme_tele_actuel(t);
	// t = chaine_precedente(t);
	// printf("Il doir y avoir Dr House pendant 1h ensuite Avanger pendant 1h sur la chaine 1\n");

	// t=avancer_dans_le_temps(t,3);
	// printf("Avancer dans le temps de 3h\n");

	// programme_tele_actuel(t);
	// t = chaine_suivante(t);
	// programme_tele_actuel(t);
	// printf("Il doir y avoir Malcolm pendant 1h ensuite Narnia pendant 1h sur la chaine 5\n");

	// t = detruire_tele(t);

	//----------------------------------------------------------------------------------------------------------------------------------------------

	return 0;
}
